unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type
  tRunCode = function(thecode, parms, res: pchar; rescount:integer): integer; stdcall;
  tRunScript = function(thefile, parms, res: pchar; rescount:integer): integer; stdcall;
  tInit = function: integer; stdcall;
  tStop = function: integer; stdcall;
  tCleanup = function: integer; stdcall;
  tGetVar = function(varname, value: pchar; valcount:integer): integer; stdcall;

var
  Form1: TForm1;
  DLLRunCode: tRunCode;
  DLLRunScript: tRunScript;
  DLLInit: tInit;
  DLLCleanup: tCleanup;
  DLLStop: tStop;
  DLLGetVar: tGetVar;
  dllH: integer;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  macro_res: pchar;
  var_value: pchar;
begin
    dllH:= LoadLibrary('mscript.dll');
    if dllH > 0 then
    begin
      @DLLInit := GetProcAddress(dllH,'Init');
      @DLLCleanup := GetProcAddress(dllH,'Cleanup');
      @DLLRunCode := GetProcAddress(dllH,'RunCode');
      @DLLRunScript := GetProcAddress(dllH,'RunScript');
      @DLLStop := GetProcAddress(dllH,'Stop');
      @DLLGetVar := GetProcAddress(dllH,'GetVar');

      DLLInit;

      macro_res := StrAlloc(MAXINT);
      DLLRunCode(pchar(Memo1.Text),pchar(Edit2.Text),macro_res,MAXINT);
      StrDispose(macro_res);

      var_value := StrAlloc(MAXINT);
      DLLGetVar('x',var_value,MAXINT);
      Edit1.Text := var_value;
      StrDispose(var_value);

      DLLCleanup;

      FreeLibrary(dllH);
    end;
end;



end.
